searchNodes=[{"doc":"Workflow engine. A basic understanding of graph theory would elucidate an intuitive grasp of this package.","ref":"Fountainedge.html","title":"Fountainedge","type":"module"},{"doc":"Returns a list of out edge nodes that are valid transitions. Same as out_edges/1, but with the nodes also for convenience.","ref":"Fountainedge.html#out_edge_nodes/1","title":"Fountainedge.out_edge_nodes/1","type":"function"},{"doc":"Returns a list of out edges that are valid transitions. The out edge is an edge leading out of a current node. Then pass the chosen edge into Fountainedge.transition/2 .","ref":"Fountainedge.html#out_edges/1","title":"Fountainedge.out_edges/1","type":"function"},{"doc":"Transition between nodes along an edge. The current nodes are tracked as a state, and parallel processess are tracked using tokens. A valid out edge must be given.","ref":"Fountainedge.html#transition/2","title":"Fountainedge.transition/2","type":"function"},{"doc":"A graph edge directionally links two nodes together. Edges are fundamental to the concept of transitioning between nodes. Graphviz is used for presentation and ranking of graph nodes. See Graphvix.Graph.add_edge/4 .","ref":"Fountainedge.Edge.html","title":"Fountainedge.Edge","type":"module"},{"doc":"Find a matching edge in a list (used internally.)","ref":"Fountainedge.Edge.html#find/2","title":"Fountainedge.Edge.find/2","type":"function"},{"doc":"Edge structure. :id - Identifier of the Fountainedge.Node where the edge is leaving (out from.) :next - Identifier of the Fountainedge.Node where the edge is pointing (in to.) :attributes Optional list of edge attributes passed to Graphvix.Graph.add_edge/4 .","ref":"Fountainedge.Edge.html#t:t/0","title":"Fountainedge.Edge.t/0","type":"type"},{"doc":"Graphing functions.","ref":"Fountainedge.Graph.html","title":"Fountainedge.Graph","type":"module"},{"doc":"Graphs a schema as a UML Activity Diagram using Graphviz . If given a workflow, the graph will be decorated with stateful information such as the current node (or nodes.) The graph can then be compiled by Graphviz: Fountainedge.Graph . graph ( workflow ) |&gt; Graphvix.Graph . compile ( &quot;workflow_graph&quot; , :svg )","ref":"Fountainedge.Graph.html#graph/1","title":"Fountainedge.Graph.graph/1","type":"function"},{"doc":"Ranks all nodes in a given schema. Will set the rank field on each Fountainedge.Node within the schema. Requires the filename of the dot file given to Graphvix.Graph.compile/3 . Useful for determining backward and forward directions between two nodes. If the rank of the out edge node is less than the current node, then the direction is backwards. Otherwise, if greater, then the direction is forwards. dot creates hierarchical or layered drawings of directed graphs. A ranking algorithmn is used to determine this heirarchy. It may be useful to use these ranks when determining direction in a workflow. Call this function to calculate ranks per each node.","ref":"Fountainedge.Graph.html#rank/2","title":"Fountainedge.Graph.rank/2","type":"function"},{"doc":"A graph node (also known as a vertex.) Graphviz is used for presentation and ranking of graph nodes. See Graphvix.Graph.add_vertex/3 . Forking and Synchronisation To create a paralell process, create a node of type :fork . The fork node must be associated with a node of type :join . The forking node will create tokens for each out edge. The join node will synchronise the parallel processes by preventing the workflow from proceeding beyond until all of these tokens are collected. Here is an example where a fork creates three tokens for each separate branch. Nodes: [ ... % Node { id : 5 , type : :fork , join : 9 } , % Node { id : 6 , label : &quot;Parallel 1&quot; } , % Node { id : 7 , label : &quot;Parallel 2&quot; } , % Node { id : 8 , label : &quot;Parallel 3&quot; } , % Node { id : 9 , type : :join } , ... ] Edges: [ ... % Edge { id : 5 , next : 6 } , % Edge { id : 5 , next : 7 } , % Edge { id : 5 , next : 8 } , % Edge { id : 6 , next : 9 } , % Edge { id : 7 , next : 9 } , % Edge { id : 8 , next : 9 } , ... ]","ref":"Fountainedge.Node.html","title":"Fountainedge.Node","type":"module"},{"doc":"Find a matching node in a list (used internally.)","ref":"Fountainedge.Node.html#find/2","title":"Fountainedge.Node.find/2","type":"function"},{"doc":"Node structure. :id - Identifier of the node. :type - Node type, one of: :normal - Normal node ( default .) :initial - Start node. :final - End node. :fork - Fork into a parallel process. The joining node must be specified. :join - Synchronise (join) a parallel process. The workflow will stop here until all tokens ( Fountainedge.Token ) generated by the fork are collected. :join - Used when forking with type :fork . Specifies the node identifier of the associated joining node where the parallel workflow will eventually synchronise. The joining node must be of type :join . :label - Optional label. :rank - Hierarchical rank of the node. The rank is used for determining backward and forward directions from the initial to final node when navigating through the workflow. The rankings are defined by calling Fountainedge.Graph.rank/2 on the schema. :attributes Optional list of node attributes passed to Graphvix.Graph.add_vertex/3 .","ref":"Fountainedge.Node.html#t:t/0","title":"Fountainedge.Node.t/0","type":"type"},{"doc":"The schema models the underlying stateless structure of a workflow as a graph consisting of nodes and edges.","ref":"Fountainedge.Schema.html","title":"Fountainedge.Schema","type":"module"},{"doc":"Schema structure. :nodes - List of nodes. :edges - List of edges.","ref":"Fountainedge.Schema.html#t:t/0","title":"Fountainedge.Schema.t/0","type":"type"},{"doc":"Tracks the current progression of the workflow (stateful.) Fountainedge.Workflow saves its status in a state list. Each active node receives a token. In linear mode, only one state is in the state list. Upon leaving a forking node, a state is created with a unique token for each out edge. Nested forks will result in multiple tokens being carried.","ref":"Fountainedge.State.html","title":"Fountainedge.State","type":"module"},{"doc":"Workflow status structure. :id - Identifier of the active Fountainedge.Node . :tokens - List of tokens carried by the active node.","ref":"Fountainedge.State.html#t:t/0","title":"Fountainedge.State.t/0","type":"type"},{"doc":"Tokens track parallel progression from a fork to a join.","ref":"Fountainedge.Token.html","title":"Fountainedge.Token","type":"module"},{"doc":"Token structure. :id - Identifier of the Fountainedge.Node from where the fork originated (type :fork .) :token - Identifier of the Fountainedge.Node where the out edge points to. Thereby, this is unique; one token is created per each out edge from the fork.","ref":"Fountainedge.Token.html#t:t/0","title":"Fountainedge.Token.t/0","type":"type"},{"doc":"Models a workflow (stateful.) The workflow is based on a Fountainedge.Schema Current nodes of the flowchart are tracked in a list of Fountainedge.State .","ref":"Fountainedge.Workflow.html","title":"Fountainedge.Workflow","type":"module"},{"doc":"Initialises a workflow. Will set the current state to the initial node specified in the schema.","ref":"Fountainedge.Workflow.html#initialize/1","title":"Fountainedge.Workflow.initialize/1","type":"function"},{"doc":"Workflow structure. :schema - The Fountainedge.Schema . :states - Workflow status.","ref":"Fountainedge.Workflow.html#t:t/0","title":"Fountainedge.Workflow.t/0","type":"type"},{"doc":"NOTICE: VERSION 0.1 to VERSION 1.0 UPGRADE HAS BREAKING API CHANGES Fountainedge is a simple workflow engine written in Elixir that roughly models forks and joins as described in the paper, Process Modeling Notations and Workflow Patterns by Stephen A. White, IBM Corporation . Uses Graphviz for graphical representations as UML Activity Diagrams. Hex Package Documentation The workflow is modelled as graphs consisting of nodes and edges. Parallel forks and joins are tracked using tokens.","ref":"readme.html","title":"Fountainedge","type":"extras"},{"doc":"Define a schema: schema = % Fountainedge.Schema { nodes : [ % Fountainedge.Node { id : 1 , label : &quot;Initial&quot; , type : :initial } , % Fountainedge.Node { id : 2 , label : &quot;Choice 1&quot; } , % Fountainedge.Node { id : 3 , label : &quot;Choice 2&quot; } , % Fountainedge.Node { id : 4 , label : &quot;Before Forking&quot; } , % Fountainedge.Node { id : 5 , type : :fork , join : 9 } , % Fountainedge.Node { id : 6 , label : &quot;Parallel 1.1&quot; } , % Fountainedge.Node { id : 7 , label : &quot;Parallel 1.2&quot; } , % Fountainedge.Node { id : 8 , label : &quot;Parallel 2&quot; } , % Fountainedge.Node { id : 9 , type : :join } , % Fountainedge.Node { id : 10 , label : &quot;After Joining&quot; } , % Fountainedge.Node { id : 11 , label : &quot;Final&quot; , type : :final } , ] , edges : [ % Fountainedge.Edge { id : 1 , next : 2 } , % Fountainedge.Edge { id : 1 , next : 3 } , % Fountainedge.Edge { id : 2 , next : 4 } , % Fountainedge.Edge { id : 3 , next : 4 } , % Fountainedge.Edge { id : 4 , next : 5 } , % Fountainedge.Edge { id : 5 , next : 6 } , % Fountainedge.Edge { id : 5 , next : 8 } , % Fountainedge.Edge { id : 6 , next : 7 } , % Fountainedge.Edge { id : 7 , next : 6 } , % Fountainedge.Edge { id : 7 , next : 9 } , % Fountainedge.Edge { id : 8 , next : 9 } , % Fountainedge.Edge { id : 9 , next : 10 } , % Fountainedge.Edge { id : 10 , next : 11 } , ] , } Initialise the workflow: workflow = Fountainedge.Workflow . initialize ( schema ) Get a list of valid out edges: Fountainedge . out_edges ( workflow ) # [%Fountainedge.Edge{id: 1, next: 2}] Transition along an out edge: workflow = Fountainedge . transition ( workflow , % Fountainedge.Edge { id : 1 , next : 2 } ) Graphing: Fountainedge.Graph . graph ( workflow ) |&gt; Graphvix.Graph . compile ( filename , :svg )","ref":"readme.html#example","title":"Fountainedge - Example","type":"extras"},{"doc":"This package can be installed by adding fountainedge to your list of dependencies in mix.exs : def deps do [ { :fountainedge , &quot;~&gt; 1.0.0&quot; } ] end","ref":"readme.html#installation","title":"Fountainedge - Installation","type":"extras"},{"doc":"2019 (c) Damien Bezborodov","ref":"readme.html#author","title":"Fountainedge - Author","type":"extras"},{"doc":"","ref":"example1.html","title":"Example: Simple","type":"extras"}]